#!/bin/sh
# This file is part of "Bad Penguin" (Kickstart module)
# Copyright (C) 1997-98-99 by Antonio GALLO

TEMPFILE="informazioni-di-sistema.txt"
echo "On `date`\nat `uname -a`\n\n" > $TEMPFILE

#1)----------------------------------------------------------

  # Drivers
  if [ -f /proc/ide/drivers ]; then
    echo >> $TEMPFILE
    echo "-----------------------------" >> $TEMPFILE
    echo "Drivers"                       >> $TEMPFILE
    echo "-----------------------------" >> $TEMPFILE      
    cat /proc/ide/drivers >> $TEMPFILE
  fi
  
  # Dischi e Cdrom
  for i in /proc/ide/hd* ; do
    if [ -d $i ]; then
      echo >> $TEMPFILE
      echo "-----------------------------" >> $TEMPFILE
      echo "Dispositivo: `basename $i`"    >> $TEMPFILE
      echo "-----------------------------" >> $TEMPFILE      
      [ -f $i/media ]    && echo "Tipo ....: `cat $i/media`"       >> $TEMPFILE
      [ -f $i/model ]    && echo "Modello .: `cat $i/model`"       >> $TEMPFILE      
      [ -f $i/driver ]   && echo "Driver ..: `cat $i/driver`"      >> $TEMPFILE
      [ -f $i/capacity ] && echo "Capacity : `cat $i/capacity` Kb" >> $TEMPFILE
      [ -f $i/cache ]    && echo "Cache ...: `cat $i/cache` Kb"    >> $TEMPFILE
      [ -f $i/geometry ] && echo -e "\n[Geometria]" >> $TEMPFILE ; cat $i/geometry >> $TEMPFILE
      [ -f $i/settings ] && echo -e "\n[Inpostazioni]" >> $TEMPFILE ; cat $i/settings >> $TEMPFILE
    fi
  done
  
  # Interfacce
  for i in /proc/ide/ide* ; do
    if [ -d $i ]; then
      echo >> $TEMPFILE
      echo "-----------------------------" >> $TEMPFILE
      echo "Interfaccia: `basename $i`"    >> $TEMPFILE
      echo "-----------------------------" >> $TEMPFILE      
      [ -f $i/channel ]  && echo "Canale .: `cat $i/channel`" >> $TEMPFILE
      [ -f $i/mate ]     && echo "Mate ...: `cat $i/mate`"    >> $TEMPFILE            
      [ -f $i/model ]    && echo "Modello : `cat $i/model`"   >> $TEMPFILE      
      [ -f $i/config ]   && echo -e "\n[Config]" >> $TEMPFILE ; cat $i/config >> $TEMPFILE
    fi
  done


# ----------------------------------------------------------------------2)
  echo -e "\n\n------------ /proc/net/dev----------------------" >> $TEMPFILE
  cat /proc/net/dev >> $TEMPFILE

# ----------------------------------------------------------------------3)  # Drivers
  if [ -f /proc/scsi/scsi ]; then
    echo >> $TEMPFILE
    echo "-----------------------------" >> $TEMPFILE
    echo "Periferiche collegate"         >> $TEMPFILE
    echo "-----------------------------" >> $TEMPFILE      
    cat /proc/scsi/scsi >> $TEMPFILE
  fi

  # Interfacce
  for i in /proc/scsi/* ; do
    if [ -d $i ]; then
      for j in $i/*; do
        if [ -f $j ]; then
          echo >> $TEMPFILE
          echo "--------------------------------------------------" >> $TEMPFILE
          echo "Interfaccia: `basename $i` - LUN: `basename $j`"    >> $TEMPFILE
          echo "--------------------------------------------------" >> $TEMPFILE      
          cat $j >> $TEMPFILE
	fi
      done
    fi
  done
  
# ----------------------------------------------------------------------4)
  echo -e "\n\n----------- cdrom-info ----------------------" >> $TEMPFILE
  cat /proc/sys/dev/cdrom/info >> $TEMPFILE

# ----------------------------------------------------------------------5)
  echo -e "\n\n----------- driver-serial -------------------" >> $TEMPFILE
  cat /proc/tty/driver/serial >> $TEMPFILE

# ----------------------------------------------------------------------6)
  echo -e "\n\n----------- cpu-info ------------------------" >> $TEMPFILE
  cat /proc/cpuinfo >> $TEMPFILE

# ----------------------------------------------------------------------7)
  echo -e "\n\n-------------- devices --------------------------" >> $TEMPFILE
  cat /proc/devices >> $TEMPFILE

# ----------------------------------------------------------------------8)
  echo -e "\n\n---------------- interupts -------------------------" >> $TEMPFILE
  cat /proc/interrupts >> $TEMPFILE

# ----------------------------------------------------------------------9)
  echo -e "\n\n------------------ ioports ----------------------------" >> $TEMPFILE
  cat /proc/ioports >> $TEMPFILE

# ----------------------------------------------------------------------A)
  echo -e "\n\n------------------- DMA --------------------------------" >> $TEMPFILE
  cat /proc/dma >> $TEMPFILE

# ----------------------------------------------------------------------B)
  echo -e "\n\n----------------- FS --------------------------------" >> $TEMPFILE
  cat /proc/filesystems >> $TEMPFILE

# ----------------------------------------------------------------------M)
  echo -e "\n\n----------------- MEM ---------------------------------" >> $TEMPFILE
  cat /proc/meminfo >> $TEMPFILE

# ----------------------------------------------------------------------C)
  echo -e "\n\n------------------- Modules -----------------------------" >> $TEMPFILE
  cat /proc/modules >> $TEMPFILE

# ----------------------------------------------------------------------D)
  echo -e "\n\n---------------- Mounts ------------------------------" >> $TEMPFILE
  cat /proc/mounts >> $TEMPFILE

# ----------------------------------------------------------------------E)
  echo -e "\n\n------------------- Partitions --------------------------" >> $TEMPFILE
  cat /proc/partitions >> $TEMPFILE

# ----------------------------------------------------------------------P)
  echo -e "\n\n---------------- PCI ---------------------------------" >> $TEMPFILE
  cat /proc/pci >> $TEMPFILE

# ----------------------------------------------------------------------F)
  echo -e "\n\n----------------- RTC ---------------------------------" >> $TEMPFILE
  cat /proc/rtc >> $TEMPFILE

# ----------------------------------------------------------------------G)
  echo -e "\n\n------------------- Sound -------------------------------" >> $TEMPFILE
  cat /proc/sound >> $TEMPFILE

# ----------------------------------------------------------------------H)
  echo -e "\n\n------------------- Swaps -------------------------------" >> $TEMPFILE
  cat /proc/swaps >> $TEMPFILE

# ----------------------------------------------------------------------K)
  echo -e "\n\n=========== DMESG ======================" >> $TEMPFILE
  dmesg >> $TEMPFILE

# DONE
