#!/bin/sh
# <BEGIN COPYRIGHT>
# This file is part of the "Bad Penguin" GNU/Linux distribution
# Copyright (C) 1997-98-99 by Antonio GALLO
# Home Page at ......: http://www.badpenguin.org
# Home Page at ......: http://www.linux.it/~agx/
# e-mail contact ....: mailto:agx@linux.it	mailto:agx@geocities.com
# This program is distributed under the GNU General Public License
# You are not allowed to remove the copyright notice
# <END COPYRIGHT>

# Configure the cdroms
# 1999-04-27, Version 1.0.0 by AGX
# 1999-10-14, Version 1.2.0 by AGX


# --- Temp Script ---
TEMPDIR="$HOME/tmp"
[ ! -d $TEMPDIR ] && mkdir -p $TEMPDIR
TEMPSCRIPT="$TEMPDIR/tempscript.$$"
TEMPDATA="$TEMPDIR/tempdata.$$"
TEMPMOUNT="$TEMPDIR/tempmount.$$"
mkdir -p $TEMPMOUNT
trap 'rm -f $TEMPDATA $TEMPSCRIPT ; rm -fR $TEMPMOUNT ; exit $USCITA' 0



# Richiede un cdrom per verificare se la scelta funziona
F_CONTROLLO_CDROM () {
  dialog --title "Controllo funzionamento del cdrom $CD_DEVICE" \
    --msgbox "\nPer piacere, inserisci un cdrom nel lettore quindi chiudi il tray,\nsuccessivamente premi INVIO per iniziare la verifica.\n" 0 0
  dialog --infobox "\n     Mounting $CD_DEVICE ...  \n" 0 0
  umount $CD_DEVICE 1>/dev/null 2>/dev/null
  umount $CD_MOUNTPOINT 1>/dev/null 2>/dev/null
  mount -o ro -t iso9660 $CD_DEVICE $CD_MOUNTPOINT 2>/dev/null
  REPLY=$?
  umount $CD_MOUNTPOINT 1>/dev/null 2>/dev/null  
  if [ $REPLY = 0 ]; then
    dialog --msgbox "\n     Cdrom $CD_DEVICE verificato con successo !     \n" 0 0
  else
    dialog --msgbox "\n   Il cdrom $CD_DEVICE non sembra funzionare correttamente ($REPLY) ... \n" 0 0
  fi
}



# Chiede se si vuole montare il cdrom in automatico al boot
F_RICHIESTA_AUTOMOUNT () {
  dialog --title "Automount del cdrom" \
    --yesno "\nDesideri che il cdrom venga montato automaticamente ad ogni avvio ?\n" 0 0
  if [ $? -eq 0 ]; then
    CD_AUTOMOUNT="auto"
  else
    CD_AUTOMOUNT="noauto"
  fi
}




# === Init vars ===
CDROM="cdrom"
CD_DEVICE="NONE"
CD_MOUNTPOINT="/cdrom"
CD_AUTOMOUNT="noauto"


# Get vars
if [ "$1" = "" ]; then
  dialog --title "Configurazione del cdrom" \
         --msgbox "\nNessun parametro ricevuto ...\nne desumo che vuoi configurare il cdrom primario\n" 0 0
  CDROM="cdrom"
  CD_MOUNTPOINT="/cdrom"
else
  CDROM="$1"
  CD_MOUNTPOINT="/$1"
fi

# Read Vars
if [ -f /etc/sysconfig/$PROFILE/$CDROM ]; then
 . /etc/sysconfig/$PROFILE/$CDROM
fi



# --------------------- Main Menu' -----------------------
while [ 0 ]; do

  dialog --title "Configurazione del cdrom" \
--menu "Attualmente '$CDROM' e' montato usando '$CD_DEVICE'\n\
Premi ESC o CANCEL per uscire oppure scegli il tuo tipo di cdrom \n" 0 0 6 \
"NONE"    "Non hai nessun cdrom                     " \
"IDE"     "Il tuo cdrom e' (E)IDE                   " \
"SCSI"    "Il tuo cdrom e' SCSI                     " \
"CUSTOM"  "Il tuo cdrom usa una vecchia interfaccia " \
"AUTO"    "Provo ad indovinare il tipo del cdrom    " \
2> $TEMPDATA

REPLY=$?
if [ $REPLY = 1 -o $REPLY = 255 ]; then
  USCITA=1 ; exit 1
fi

CHOICE=`cat $TEMPDATA`



if [ $CHOICE = "NONE" ]; then
  CD_DEVICE="NONE"
  break;


  
elif [ $CHOICE = "IDE" ]; then
    dialog  --title "Scegli un'interfaccia (E)IDE" --menu "Per piacere, specifica manualmente quale interfaccia usa il cdrom." 0 0 5 \
    "/dev/hda"  "Controller Primario Master       " \
    "/dev/hdb"  "Controller Primario Slave        " \
    "/dev/hdc"  "Controller Secondario Master     " \
    "/dev/hdd"  "Controller Secondario Slave      " \
    2> $TEMPDATA
    REPLY=$?
    if [ $REPLY = 1 -o $REPLY = 255 ]; then
      break;
    fi
    CD_DEVICE=`cat $TEMPDATA`
    F_CONTROLLO_CDROM
    F_RICHIESTA_AUTOMOUNT
    break    



elif [ $CHOICE = "SCSI" ]; then
    dialog  --title "Scegli un'interfaccia SCSI" --menu "Per piacere, specifica manualmente quale interfaccia usa il cdrom." 0 0 5 \
    "/dev/scd0"  "Primo   cdrom SCSI        " \
    "/dev/scd1"  "Secondo cdrom SCSI        " \
    "/dev/scd2"  "Terzo   cdrom SCSI        " \
    "/dev/scd3"  "Quarto  cdrom SCSI        " \
    2> $TEMPDATA 
    REPLY=$?
    if [ $REPLY = 1 -o $REPLY = 255 ]; then
      break;
      USCITA=1 ; exit 1
    fi
    CD_DEVICE=`cat $TEMPDATA`
    F_CONTROLLO_CDROM
    F_RICHIESTA_AUTOMOUNT
    break    


    
elif [ $CHOICE = "CUSTOM" ]; then
    dialog  --title "Scegli un'interfaccia proprietaria"  --menu "Per piacere, specifica manualmente quale interfaccia usa il cdrom." 0 0 12 \
    "/dev/cdu31a"  "Sony CDU31A/CDU33A                       " \
    "/dev/cdu535"  "Sony 531/535                             " \
    "/dev/mcd"     "Mitsumi (proprietaria, non IDE)          " \
    "/dev/mcdx0"   "New Mitsumi (anche non IDE)              " \
    "/dev/sbpcd"   "Sound Blaster Pro/Panasonic              " \
    "/dev/aztcd"   "Aztech/Orchid/Okano/Wearnes Cdrom        " \
    "/dev/cm205cd" "Phillips old CDROM                       " \
    "/dev/cm206cd" "Phillips and some ProAudio Spectrum 16   " \
    "/dev/gscd"    "Goldstar R420                            " \
    "/dev/optcd"   "Optics Storage 8000                      " \
    "/dev/sjcd"    "Sanyo CDR-H94 + ISP16 soundcard          " \
    "/dev/hitcd"   "Hitachi CDROM                            " \
    2> $TEMPDATA 
    REPLY=$?
    if [ $REPLY = 1 -o $REPLY = 255 ]; then
      break;
      USCITA=1 ; exit 1
    fi
    CD_DEVICE=`cat $TEMPDATA`
    F_CONTROLLO_CDROM
    F_RICHIESTA_AUTOMOUNT
    break    



elif [ $CHOICE = "AUTO" ]; then
  dialog --title "Ricerca automatica del cdrom" \
    --msgbox "\nPer piacere, inserisci un cdrom nel lettore quindi chiudi il tray,\nsuccessivamente premi INVIO per iniziare la verifica.\n\
Se non inserisci un cdrom leggibile nel lettore\nsara' impossibile effettuare la verifica automatica !\n" 0 0

  SUCCESS=0
  for device in \
	/dev/scd0 /dev/scd1 /dev/scd2 /dev/scd3 \
	/dev/hdd /dev/hdc /dev/hdb /dev/hda \
	/dev/hde /dev/hdf /dev/hdg /dev/hdh 
  do
# AGX: Per problemi legati alla lentezza di terminati moduli ho preferito disabilitare
# questi cdrom ormai obsoleti
#	/dev/sbpcd /dev/aztcd /dev/sonycd /dev/cdu535 /dev/mcd \
#	/dev/cm206cd /dev/gscd0 /dev/mcdx0 /dev/mcdx1 \
#	/dev/optcd0 /dev/sjcd ; do

    
    dialog --infobox "\n     Verifica di $device...     \n" 0 0
    umount $CD_MOUNTPOINT 1>/dev/null 2>/dev/null
    mount -o ro -t iso9660 $device $CD_MOUNTPOINT 1>/dev/null 2>/dev/null
    REPLY=$?
    umount $CD_MOUNTPOINT 1>/dev/null 2>/dev/null
    if [ $REPLY = 0 ]; then
      dialog --title "Cdrom verificato con successo" \
--yesno "\nUn cdrom e' stato trovato in $device. Si tratta del cdrom giusto ?\n" 0 0
      if [ $? -eq 0 ]; then
	CD_DEVICE="$device"
        F_RICHIESTA_AUTOMOUNT
	SUCCESS=1
        break    
      fi
    fi
  done
  #
  if [ $SUCCESS -eq 1 ]; then
    break
  else
    dialog --msgbox "\n     Spiacente, nessun cdrom e' stato trovato !     \n" 0 0
    CD_DEVICE="NONE"
  fi    



else
    echo "Wrong Option, giving up !"
    echo $CD_DEVICE
    echo $DEVICE
    echo "debug"    
    read x
fi

# Main Menu'
done


# Perform Changes
/etc/init.d/cdrom.rc
echo "CD_DEVICE=$CD_DEVICE"          > /etc/sysconfig/$PROFILE/$CDROM
echo "CD_MOUNTPOINT=$CD_MOUNTPOINT" >> /etc/sysconfig/$PROFILE/$CDROM
echo "CD_AUTOMOUNT=$CD_AUTOMOUNT"   >> /etc/sysconfig/$PROFILE/$CDROM
/etc/init.d/cdrom.rc init
/etc/init.d/cdrom.rc start

echo -e "\nPremi INVIO per continuare ..."
read x
USCITA=0
exit 0
