#!/bin/sh
# <BEGIN COPYRIGHT>
# This file is part of the "Bad Penguin" GNU/Linux distribution
# Copyright (C) 1997-98-99 by Antonio GALLO
# Home Page at ......: http://www.badpenguin.org
# Home Page at ......: http://www.linux.it/~agx/
# e-mail contact ....: mailto:agx@linux.it	mailto:agx@geocities.com
# This program is distributed under the GNU General Public License
# You are not allowed to remove the copyright notice
# <END COPYRIGHT>


# Configure the console font
# 1997-02-14, Version 1.1.0 by AGX
# 1999-04-27, Version 1.1.2 by AGX
# 1999-10-01, Version 1.6.0 by AGX

# --- Temp Script ---
TEMPDIR="$HOME/tmp"
[ ! -d $TEMPDIR ] && mkdir -p $TEMPDIR
TEMPSCRIPT="$TEMPDIR/tempscript.$$"
TEMPDATA="$TEMPDIR/tempdata.$$"
trap 'rm -f $TEMPDATA $TEMPSCRIPT ; exit $USCITA' 0


# Check Dir
CONSOLEDIR="/usr/lib/kbd/consolefonts"
if [ ! -d $CONSOLEDIR  ]; then
  CONSOLEDIR="/usr/share/kbd/consolefonts"
  if [ ! -d $CONSOLEDIR  ]; then
    CONSOLEDIR="/usr/share/consolefonts"
    if [ ! -d $CONSOLEDIR  ]; then
      dialog --msgbox "\n PROBLEMA: La directory con i font non e' stata trovata ! \n" 0 0
      USCITA=1 ; exit 1
    fi
  fi
fi

# Get Current Font value
if [ -f /etc/sysconfig/$PROFILE/fonts ]; then
  . /etc/sysconfig/$PROFILE/fonts
fi

# Splash
dialog --infobox "\n Carico la lista dei fonts ... \n" 0 00

# Build List
cat << EOF >$TEMPSCRIPT
dialog --title "Selezione dei font per il profilo $PROFILE" --menu "
Usa i tasti freccia per selezionare un font della console.
Quindi premi INVIO per confermare la tua scelta.
Il font di default e' il file : 'default8x16'

Il font corrente e' [ $CONSOLEFONT ]
" 25 68 11       \\
EOF

for mapname in $CONSOLEDIR/*; do
   REALNAME="`basename $mapname`"
   echo "\"$REALNAME\" \"\" \\" >> $TEMPSCRIPT
done

echo "2>$TEMPDATA" >> $TEMPSCRIPT
echo 'ERROR=$?' >> $TEMPSCRIPT
echo 'if [ $ERROR = 1 -o $ERROR = 255 ]; then' >> $TEMPSCRIPT
echo '  USCITA=1 ; exit 1' >> $TEMPSCRIPT
echo 'fi' >> $TEMPSCRIPT

# Run the script
sh $TEMPSCRIPT
if [ $? = 1 ]; then
  	rm -f $TEMPDATA $TEMPSCRIPT
  	clear
  	echo "Nessun cambiamento effettuato."
else
	MAPNAME="`cat $TEMPDATA`"
	echo CONSOLEFONT="$CONSOLEDIR/$MAPNAME"  >  /etc/sysconfig/$PROFILE/fonts
	# Load the font
	echo "Loading new font map ..."
	sh /etc/init.d/console-fonts.rc init
	sh /etc/init.d/console-fonts.rc start
	echo -e "\nPremi INVIO per continuare ..."
	read x
fi
