#!/bin/sh
# <BEGIN COPYRIGHT>
# This file is part of the "Bad Penguin" GNU/Linux distribution
# Copyright (C) 1997-98-99 by Antonio GALLO
# Home Page at ......: http://www.badpenguin.org
# Home Page at ......: http://www.linux.it/~agx/
# e-mail contact ....: mailto:agx@linux.it	mailto:agx@geociti
# This program is distributed under the GNU General Public License
# You are not allowed to remove the copyright notice
# <END COPYRIGHT>

# Edita /etc/inetd.conf
# 1.0.0 by agx@linux.it 
# 1.6.0 by AGX 1999-11-03

# --- Temp Script ---
TEMPDIR="$HOME/tmp"
[ ! -d $TEMPDIR ] && mkdir -p $TEMPDIR
TEMPSCRIPT="$TEMPDIR/tempscript.$$"
TEMPDATA="$TEMPDIR/tempdata.$$"
mkdir -p $TEMPMOUNT
trap 'rm -f $TEMPDATA $TEMPSCRIPT ; exit $USCITA' 0


edita_inetdconf(){
    ENABLED="NO"
    SERVICE=""
    SOCKET_TYPE="stream"
    PROTO="tcp"
    FLAGS="nowait"
    USER="root"
    SERVER_PATH="/usr/bin/tcpd"
    SERVER_ARGS=""
    . $1
    
    while [ 0 ]; do

        dialog --title "Modifica voce di menu" --menu "Modifica i parametri del servizio. E' obbligatorio fornire un valore per ogni voce del menu' " 21 50 11 \
	    "ENABLED "  "$ENABLED" \
	    "PORT    "  "$SERVICE" \
	    "SOCKET  "  "$SOCKET_TYPE" \
	    "PROTOCOL"  "$PROTO" \
	    "FLAGS   "  "$FLAGS" \
	    "USER    "  "$USER" \
	    "SERVER  "  "$SERVER_PATH" \
	    "ARGS    "  "$SERVER_ARGS" \
	    "--------"  "------------------" \
	    "SAVE    "  "Save the changes" \
	    "REMOVE  "  "Remove this item" \
				2> $TEMPSCRIPT
	if [ $? -ne 0 ]; then
	    return 1
	fi
	CHOICE="`cat $TEMPSCRIPT`"

	case "$CHOICE" in
	    "ENABLED ")
		dialog --yesno "\n     Vuoi abilitare questo demone ?     \n" 0 0
		if [ $? -eq 0 ]; then
		    ENABLED="YES"
		else
		    ENABLED="NO"
		fi
		;;
		
	    "PORT    ")
		dialog --inputbox "Inserisci il nome o il numero della socket del servizio. I nomi dei servizi si trovano nel file /etc/services." 10 60 $SERVICE 2> $TEMPSCRIPT
		if [ $? -eq 0 ]; then
		    SERVICE="`cat $TEMPSCRIPT`"
		fi		
		;;
		
	    "SOCKET  ")
	        MSG="Questo campo descrive il tipo di socket che questo demone usera', puoi scegliere tra: stream, dgram, raw, rdm, o seqpacket. Tutti i servizi basati su tcp usano di solito 'stream'."
		dialog --inputbox "$MSG" 15 60 $SOCKET_TYPE 2> $TEMPSCRIPT
		if [ $? -eq 0 ]; then
		    SOCKET_TYPE="`cat $TEMPSCRIPT`"
		fi		
		;;

	    "PROTOCOL")
	        MSG="Il protocollo usato da questo demone. Di solito e' 'tcp' o 'udp'. Demoni basati su Sun RPC usano 'rpc/tcp' o 'rpc/udp'."
		dialog --inputbox "$MSG" 13 60 $PROTO 2> $TEMPSCRIPT
		if [ $? -eq 0 ]; then
		    PROTO="`cat $TEMPSCRIPT`"
		fi		
		;;

	    "FLAGS   ")
	        MSG="Ci sono solo due possibili valori per questo campo: nowait e wait. Sostanzialmente questo campo indica se inetd deve avviare un nuovo daemon quando arriva una nuova richiesta (nowait) oppure e' il demone a gestirne di nuove (wait)."
		dialog --inputbox "$MSG" 11 70 $FLAGS 2> $TEMPSCRIPT
		if [ $? -eq 0 ]; then
		    FLAGS="`cat $TEMPSCRIPT`"
		fi		
		;;

	    "USER    ")
	        MSG="Indica l'account utente che verra' settato per il demone quando verra' avviato."
		dialog --inputbox "$MSG" 10 60 $USER 2> $TEMPSCRIPT
		if [ $? -eq 0 ]; then
		    USER="`cat $TEMPSCRIPT`"
		fi		
		;;

	    "SERVER  ")
	        MSG="E' il pathname del demone da eseguire. Se si usa 'tcpd' come wrapper, il nome del server realmente eseguito va nel parametro successivo."
		dialog --inputbox "$MSG" 12 60 $SERVER_PATH 2> $TEMPSCRIPT
		if [ $? -eq 0 ]; then
		    SERVER_PATH="`cat $TEMPSCRIPT`"
		fi		
		;;

	    "ARGS    ")
	        MSG="La command line che viene passata al demone."
		dialog --inputbox "$MSG" 10 60 $SERVER_ARGS 2> $TEMPSCRIPT
		if [ $? -eq 0 ]; then
		    SERVER_ARGS="`cat $TEMPSCRIPT`"
		fi		
		;;

	    "SAVE    ")
		    > $1
		    echo "ENABLED=$ENABLED"	>> $1
		    echo "SERVICE=$SERVICE"	>> $1
		    echo "SOCKET_TYPE=$SOCKET_TYPE"	>> $1
		    echo "PROTO=$PROTO"	>> $1
		    echo "FLAGS=$FLAGS"	>> $1
		    echo "USER=$USER"	>> $1
		    echo "SERVER_PATH=$SERVER_PATH"	>> $1
		    echo "SERVER_ARGS=$SERVER_ARGS"	>> $1
		    dialog --msgbox "Il file $1 e' stato salvato !" 0 0
		    return 0
		;;
		
	    "REMOVE  ")
		rm -f $1
		dialog --msgbox "Il file $1 e' stato rimosso !" 0 0
		return 0
		;;
	esac
    done
    return 0
}



# ===========
# MAIN
# ===========
while [ 0 ]; do

  # Lettura dati
  > $TEMPSCRIPT
  for i in /etc/sysconfig/$PROFILE/*.inetd; do
    if [ -f $i ]; then
      FILENAME="`basename $i .inetd`"
      SERVICE="sconosciuto"
      DESCRIPTION="sconosciuto"
      . $i
      if [ "$ENABLED" = "YES" ]; then
        DESCRIPTION="Abilitato"
      else
        DESCRIPTION="Disabilitato"      
      fi
      echo -n "$FILENAME:$SERVICE  ($DESCRIPTION):" >> $TEMPSCRIPT
    fi
  done
  echo -n "   :-----------------------:" >> $TEMPSCRIPT
  echo -n "ADD:Aggiungi una nuova voce:" >> $TEMPSCRIPT
  echo -n "APPLY:Applica le modifiche a inetd:" >> $TEMPSCRIPT

  # Visualizza menu'
  IFS=":"
  dialog --title "Configurazione di Inetd" --menu "Questo e' l'elenco dei servizi configurati per funzionare tramite inetd" 20 50 10 `cat $TEMPSCRIPT` 2> $TEMPSCRIPT
  if [ $? -ne 0 ]; then
    USCITA=1 ; exit 1
  fi
  CHOICE="`cat $TEMPSCRIPT`"
  FILENAME="/etc/sysconfig/$PROFILE/$CHOICE.inetd"


  # === Applica modifiche ===
  if [ "$CHOICE" = "APPLY" ]; then
    clear
    
    # Togle il lock al servizio
    echo "RUNME=AUTO" > /etc/sysconfig/$PROFILE/inetd
    
    # Crea file
    FILENAME="/etc/sysconfig/$PROFILE/inetd.conf"
    echoc GREEN "Creazione del file $FILENAME"
    echo
    > $FILENAME
    for i in /etc/sysconfig/$PROFILE/*.inetd; do
      if [ -f $i ]; then
	echo "- $i"
        echo "# $i" >> $FILENAME
        . $i
        if [ "$ENABLED" = "NO" ]; then
	  echo -n "# " >> $FILENAME
	fi
	echo "$SERVICE  $SOCKET_TYPE  $PROTO  $FLAGS  $USER  $SERVER_PATH  $SERVER_ARGS"  >> $FILENAME
      fi
    done				
    echo
    echo "Saving as /etc/inetd.conf ..."
    cp $FILENAME /etc/inetd.conf
    echo
    service inetd restart
    echo
    echo "PRESS ENTER TO CONTINUE ..."
    read x
    #
    continue
  fi
  
  
  
  # === Aggiunge voce ===
  if [ "$CHOICE" = "ADD" ]; then
    dialog --inputbox "Nome simbolico da dare al servizio" 8 60 2> $TEMPSCRIPT
    if [ $? -ne 0 ]; then
      continue
    fi
    CHOICE="`cat $TEMPSCRIPT`"
    if [ "$CHOICE" = "" ]; then
      continue
    else
      FILENAME="/etc/sysconfig/$PROFILE/$CHOICE.inetd"
      > $FILENAME
    fi    
  fi

  
  # Modifica
  if [ -f $FILENAME ]; then
    edita_inetdconf $FILENAME    
  fi

done

exit 0
