#!/bin/sh
# <BEGIN COPYRIGHT>
# This file is part of the "Bad Penguin" GNU/Linux distribution
# Copyright (C) 1997-98-99 by Antonio GALLO
# Home Page at ......: http://www.badpenguin.org
# Home Page at ......: http://www.linux.it/~agx/
# e-mail contact ....: mailto:agx@linux.it	mailto:agx@geocities.com
# This program is distributed under the GNU General Public License
# You are not allowed to remove the copyright notice
# <END COPYRIGHT>

# Configure the keyboard layout
# Orginal source derived from slackware setup
# 1997-02-14, Version 1.1.0 by AGX
# 1999-04-27, Version 1.1.2 by AGX
# 1999-11-03, Version 1.6.0 by AGX

# --- Temp Script ---
TEMPDIR="$HOME/tmp"
[ ! -d $TEMPDIR ] && mkdir -p $TEMPDIR
TEMPSCRIPT="$TEMPDIR/tempscript.$$"
TEMPDATA="$TEMPDIR/tempdata.$$"
trap 'rm -f $TEMPDATA $TEMPSCRIPT ; exit $USCITA' 0



KBD_DIR=/usr/lib/kbd/keytables
if [ ! -d $KBD_DIR ]; then
  KBD_DIR=/usr/share/keytables
fi
if [ ! -d $KBD_DIR ]; then
  dialog \
    --title "Mancano le mappe della tastiera !" \
    --msgbox "Impossibile trovare la directory $KBD_DIR che contiene le mappe della tastiera ! \
" 0 0
   USCITA=1 ; exit 1
fi

# Get Current keyboard value
KEYTABLE="NONE"
if [ -f /etc/sysconfig/$PROFILE/keyboard ]; then
  . /etc/sysconfig/$PROFILE/keyboard
fi

cat << EOF > $TEMPSCRIPT
dialog --title "Selezione della mappa della tastiera" --menu "
Use the arrow key to select your keyboard layout.
Then press ENTER to confirm your choice.

The current value is [ `basename $KEYTABLE .map` ]
" 25 68 12 \\
EOF

for mapname in $KBD_DIR/*.map; do
  if [ -f $mapname ]; then
    REALNAME="`basename $mapname .map`"
    echo "\"$REALNAME\" \"\" \\" >> $TEMPSCRIPT
  fi
done
for mapname in $KBD_DIR/*.map.gz; do
  if [ -f $mapname ]; then
    REALNAME="`basename $mapname .map.gz`"
    echo "\"$REALNAME\" \"\" \\" >> $TEMPSCRIPT
  fi
done

echo "2> $TEMPDATA" >> $TEMPSCRIPT
echo 'ERROR=$?' >> $TEMPSCRIPT
echo 'if [ $ERROR = 1 -o $ERROR = 255 ]; then' >> $TEMPSCRIPT
echo '  USCITA=1 ; exit 1' >> $TEMPSCRIPT
echo 'fi' >> $TEMPSCRIPT

# Run the script
sh $TEMPSCRIPT
REPLY=$?
if [ $REPLY = 1 -o $REPLY = 255 ]; then
  rm -f $TEMPDATA $TEMPSCRIPT
  clear
  echo "No changes made."
else
  MAPNAME="`cat $TEMPDATA`"
  KEYTABLE="$KBD_DIR/$MAPNAME.map"
  if [ ! -f $KEYTABLE ]; then
    KEYTABLE="$KBD_DIR/$MAPNAME.map.gz"
  fi
  # Load keyboard map (if any) when booting
  echo "KEYTABLE=$KEYTABLE" > /etc/sysconfig/$PROFILE/keyboard
  echo "MAPNAME=$MAPNAME"  >> /etc/sysconfig/$PROFILE/keyboard
  # Load the new keytable
  chmod 666 /dev/port
  echo "Loading the new keyboard table ..."
  sh /etc/init.d/keyboard-layout.rc start
  echo -e "\nPress ENTER to continue ..."
  read x
fi
