#!/bin/sh
# <BEGIN COPYRIGHT>
# This file is part of the "Bad Penguin" GNU/Linux distribution
# Copyright (C) 1997-98-99 by Antonio GALLO
# Home Page at ......: http://www.badpenguin.org
# Home Page at ......: http://www.linux.it/~agx/
# e-mail contact ....: mailto:agx@linux.it	mailto:agx@geocities.com
# This program is distributed under the GNU General Public License
# You are not allowed to remove the copyright notice
# <END COPYRIGHT>

# Setup Mouse type
# 1999-04-27, Version 1.1.0 by AGX
# 1999-11-07, Version 1.6.0 by AGX

# --- Temp Script ---
TEMPDIR="$HOME/tmp"
[ ! -d $TEMPDIR ] && mkdir -p $TEMPDIR
TEMPSCRIPT="$TEMPDIR/tempscript.$$"
TEMPDATA="$TEMPDIR/tempdata.$$"
trap 'rm -f $TEMPDATA $TEMPSCRIPT ; exit $USCITA' 0



dialog --title "Configurazione del Mouse [$PROFILE] " --menu "Scegli il tipo del mouse :" 16 60 8 \
  "1" "Microsoft compatibile o mouse seriale " \
  "2" "IBM style PS/2 mouse        (IRQ 12)  " \
  "3" "Logitech Bus Mouse                    " \
  "4" "Logitech Serial Mouse                 " \
  "5" "ATI XL Bus Mouse                      " \
  "6" "Microsoft Bus Mouse                   " \
  "7" "Mouse Systems serial mouse (3 buttons)" 2> $TEMPDATA 
  REPLY=$?
  if [ $REPLY = 1 -o $REPLY = 255 ]; then
    USCITA=1 ; exit 1
  fi

  # Acquisisce risposta dell'utente
  MOUSE_TYPE="`cat $TEMPDATA`"

  # Ferma il servizio, se attivo
  /usr/local/sbin/service gpm stop

  # ------------------------------------------------- Richiesta porta seriale
  if [ "$MOUSE_TYPE" = "1" -o "$MOUSE_TYPE" = "4" -o "$MOUSE_TYPE" = "7" ]; then
 
    > $TEMPSCRIPT
    setserial -bg /dev/ttyS[0123] | while read DEVICE LINEA
    do
      echo -n "$DEVICE:$LINEA:" >> $TEMPSCRIPT
    done
    IFS=":"
    dialog --title "Scegli una porta seriale " --menu "Il tuo mouse necessita'\n\
di una porta seriale per funzionare, quale ? \n" 13 60 4 `cat $TEMPSCRIPT` 2> $TEMPDATA
    REPLY=$?
    IFS=" "
    if [ $REPLY -ne 0 ]; then
      USCITA=2 ; exit 2
    fi

    # Acquisisce sclata porta seriale
    MOUSE_DEVICE="`cat $TEMPDATA`"

    if [ "$MOUSE_TYPE" = "1" ]; then
      MTYPE="Microsoft"
      MGPM="ms"
    elif [ "$MOUSE_TYPE" = "4" ]; then
       MTYPE="Logitech"
       MGPM="logi"
    else	
       MTYPE="MouseSystems"
       MGPM="msc"
    fi

    # Crea Link per i mouse seriali
    rm -f /dev/mouse
    ln -sf /dev/$MOUSE_DEVICE /dev/mouse
 
 # ----------------------------------------------------------- Scelta PS/2
 elif [ "$MOUSE_TYPE" = "2" ]; then
   rm -f /dev/mouse
   ln -sf /dev/psaux /dev/mouse
   MTYPE="PS\/2"
   MGPM="ps2"
   MOUSE_DEVICE="/dev/psaux"
 # -------------------------------------------------------- Logitech Bus Mouse
 elif [ "$MOUSE_TYPE" = "3" ]; then
   (cd /dev; ln -sf /dev/logibm mouse)
   MTYPE="BusMouse"
   MGPM="bm"
   MOUSE_DEVICE="/dev/logibm"
 # ------------------------------------------------------- ATI XL Bus Mouse 
 elif [ "$MOUSE_TYPE" = "5" ]; then
   (cd /dev; ln -sf /dev/atibm mouse)
   MTYPE="BusMouse"
   MGPM="bm"
   MOUSE_DEVICE="/dev/atibm"
 # -------------------------------------------------------- Bus Mouse 
 elif [ "$MOUSE_TYPE" = "6" ]; then
   (cd /dev; ln -sf /dev/msbm mouse)
   MTYPE="BusMouse"
   MGPM="bm"
   MOUSE_DEVICE="/dev/msbm"
 fi
# ------------------ End of Configuration of /dev/mouse

# ------------------------------------------------- Setup gpm & restart it
service gpm stop
echo MOUSETYPE="$MTYPE" 	 > /etc/sysconfig/$PROFILE/mouse
echo XEMU3=no			>> /etc/sysconfig/$PROFILE/mouse
echo GPM_TYPE=$MGPM		>> /etc/sysconfig/$PROFILE/mouse
echo MOUSE_DEVICE=$MOUSE_DEVICE	>> /etc/sysconfig/$PROFILE/mouse
service gpm restart
echo -e "\nPremi INVIO per continuare ..."
read x

# ------------------------------------------------- Setup Xconfig (obsolete)
# This is now done by "xfree-configurator" that read
# the "MOUSETYPE" variable

# -------------------------------------------- Setup Ylibvga.config (disabled)
# Configuration of SVGA lib is still to do !
# (cat /usr/local/lib/Ylibvga.config | sed -e s/MOUSE_TYPE_GOES_HERE/$MTYPE/ >/usr/local/lib/libvga.config)