#!/bin/sh
# <BEGIN COPYRIGHT>
# This file is part of the "Bad Penguin" GNU/Linux distribution
# Copyright (C) 1997-98-99 by Antonio GALLO
# Home Page at ......: http://www.badpenguin.org
# Home Page at ......: http://www.linux.it/~agx/
# e-mail contact ....: mailto:agx@linux.it	mailto:agx@geocities.com
# This program is distributed under the GNU General Public License
# You are not allowed to remove the copyright notice
# <END COPYRIGHT>

# Configure the given interface passed by netdevice.sh
# 1999-04-27, Version 1.0.0 by AGX
# 1999-09-15, Version 1.4.1 by AGX
# 1999-11-07, Version 1.6.0 by AGX


# --- Temp Script ---
TEMPDIR="$HOME/tmp"
[ ! -d $TEMPDIR ] && mkdir -p $TEMPDIR
TEMPSCRIPT="$TEMPDIR/tempscript.$$"
TEMPDATA="$TEMPDIR/tempdata.$$"
mkdir -p $TEMPMOUNT
trap 'rm -f $TEMPDATA $TEMPSCRIPT ; exit $USCITA' 0


# --- Controlli ---
if [ "$1" = "" ]; then
    dialog --msgbox "Sorry, no device passed as parameters !!" 6 40
    USCITA=1 ; exit 1
fi
cat /proc/net/dev | grep -q $1
if [ $? -ne 0 ]; then
    dialog --msgbox "\nATTENZIONE:\
    \nIl dispositivo *$1* non e' presente nel tuo sistema.\
    \nPuo' essere configurato ugualmente ma e' meglio se \
    \ncarichi qualche modulo prima !\n" 0 0
fi


# Load default values
if [ -f /etc/sysconfig/$PROFILE/network ]; then
  . /etc/sysconfig/$PROFILE/network
  I_HOSTNAME=$HOSTNAME
  I_DOMAINNAME=$DOMAINNAME
else
  I_HOSTNAME=localhost
  I_DOMAINNAME=localnet
fi


# Set default values
HOSTNAME=$I_HOSTNAME
DOMAINNAME=$I_DOMAINNAME
IPADDR=127.0.0.1
DHCP=NO
NETWORK=127.0.0.0
BROADCAST=127.0.0.255
NETMASK=255.255.255.0
GATEWAY=
DNS1=
DNS2=

if [ -f /etc/sysconfig/$PROFILE/$1.interface ]; then
  . /etc/sysconfig/$PROFILE/$1.interface
fi


while [ 0 ]; do

dialog --title "Configurazione dell'interfaccia [ $1 ] " --menu "Questo menu' \
ti consente di cambiare i valori della tua interfaccia di rete.\n\
FAI ATTENZIONE, SE SALVI I DATI CANCELLARI LE IMPOSTAZIONI DI RETE\n\
FATTE MANUALMENTE !!!" \
25 78 13 \
"Hostname"           "$HOSTNAME ($I_HOSTNAME)" \
"Domain name"        "$DOMAINNAME ($I_DOMAINNAME)" \
"IP Address"         "$IPADDR" \
"DHCP"               "$DHCP" \
"NETWORK Address"    "$NETWORK" \
"BROADCAST Address"  "$BROADCAST" \
"SUBNET MASK"        "$NETMASK" \
"Gateway"	     "$GATEWAY" \
"DNS Server 1"	     "$DNS1" \
"DNS Server 2"	     "$DNS2" \
" " " " \
"SAVE & EXIT"        "Usa questo per salvare ed uscire" \
" " " " \
"Remove" 	     "Rimuove le impostazioni di questa interfaccia" \
2>$TEMPDATA

# Scelta
REPLY=$?
if [ $REPLY = 1 -o $REPLY = 255 ]; then
  USCITA=1 ; exit 1
fi
CHOICE="`cat $TEMPDATA`"

# Case
if [ "$CHOICE" = "Hostname" ]; then
  dialog --title "ENTER HOSTNAME" --inputbox "" 8 40 $I_HOSTNAME 2> $TEMPDATA
  if [ $? = 0 ]; then
    HOSTNAME=`cat $TEMPDATA`  
  fi

elif [ "$CHOICE" = "Domain name" ]; then
  dialog --title "ENTER DOMAINNAME" --inputbox "" 8 40 $I_DOMAINNAME 2> $TEMPDATA
  if [ $? = 0 ]; then
    DOMAINNAME=`cat $TEMPDATA`  
  fi

elif [ "$CHOICE" = "IP Address" ]; then
  dialog --title "ENTER IP Address" --inputbox "" 8 40 $IPADDR 2> $TEMPDATA
  if [ $? = 0 ]; then
    IPADDR=`cat $TEMPDATA`  
  fi

elif [ "$CHOICE" = "DHCP" ]; then
  dialog --title "Enable DHCP" --yesno "Vuoi usare il DHCP (Dynamic Host Configuration Protocol) invece di un IP Address statico ?" 8 40 2> $TEMPDATA
  if [ $? = 0 ]; then
    IPADDR="0.0.0.0"
    DHCP="YES"
  else
    DHCP="NO"
  fi 

elif [ "$CHOICE" = "NETWORK Address" ]; then
  TMPIP="`echo $IPADDR | cut -f 1-3 -d '.' `.0"
  dialog --title "ENTER NETWORK Address" --inputbox "" 8 40 $TMPIP 2> $TEMPDATA
  if [ $? = 0 ]; then
    NETWORK=`cat $TEMPDATA`  
  fi

elif [ "$CHOICE" = "SUBNET MASK" ]; then
  dialog --title "ENTER NETMASK" --inputbox "" 8 40 $NETMASK 2> $TEMPDATA
  if [ $? = 0 ]; then
    NETMASK=`cat $TEMPDATA`  
  fi

elif [ "$CHOICE" = "BROADCAST Address" ]; then
  TMPIP="`echo $IPADDR | cut -f 1-3 -d '.' `.255"
  dialog --title "ENTER BROADCAST Address" --inputbox "" 8 40 $TMPIP 2> $TEMPDATA
  if [ $? = 0 ]; then
    BROADCAST=`cat $TEMPDATA`  
  fi

elif [ "$CHOICE" = "Gateway" ]; then
  TMPIP="`echo $IPADDR | cut -f 1-3 -d '.' `.1"
  dialog --title "ENTER GATEWAY Address" --inputbox "" 8 40 $TMPIP 2> $TEMPDATA
  if [ $? = 0 ]; then
    GATEWAY=`cat $TEMPDATA`  
  fi
elif [ "$CHOICE" = "DNS Server 1" ]; then
  dialog --title "ENTER GATEWAY Address" --inputbox "" 8 40 $DNS1 2> $TEMPDATA
  if [ $? = 0 ]; then
    DNS1=`cat $TEMPDATA`  
  fi
elif [ "$CHOICE" = "DNS Server 2" ]; then
  dialog --title "ENTER GATEWAY Address" --inputbox "" 8 40 $DNS2 2> $TEMPDATA
  if [ $? = 0 ]; then
    DNS2=`cat $TEMPDATA`  
  fi
elif [ "$CHOICE" = "Remove" ]; then
  echoc PURPLE "Chiudo l'interfaccia $1"
  ifconfig $1 down
  echoc PURPLE "Elimino il file di configurazione per $1"  
  rm -f /etc/sysconfig/$PROFILE/$1.interface
  echo "fatto." ; echo
  echoc GREEN "Premi INVIO per continuare ..." ; read x  
  USCITA=1 ; exit 1  
elif [ "$CHOICE" = " " ]; then
  echo ""
else
  # SAVE
  break;
fi

done

# Writing Info

#echo "Stopping Network ..."
/etc/init.d/netdevice.rc stop $1
echo "Saving Network settings"
> /etc/sysconfig/$PROFILE/$1.interface
echo HOSTNAME=$HOSTNAME		>> /etc/sysconfig/$PROFILE/$1.interface
echo DOMAINNAME=$DOMAINNAME	>> /etc/sysconfig/$PROFILE/$1.interface
echo IPADDR=$IPADDR	 	>> /etc/sysconfig/$PROFILE/$1.interface
echo NETWORK=$NETWORK		>> /etc/sysconfig/$PROFILE/$1.interface
echo NETMASK=$NETMASK	 	>> /etc/sysconfig/$PROFILE/$1.interface
echo BROADCAST=$BROADCAST	>> /etc/sysconfig/$PROFILE/$1.interface
echo GATEWAY=$GATEWAY	 	>> /etc/sysconfig/$PROFILE/$1.interface
echo DNS1=$DNS1	 		>> /etc/sysconfig/$PROFILE/$1.interface
echo DNS2=$DNS2	 		>> /etc/sysconfig/$PROFILE/$1.interface
echo DHCP=$DHCP	 		>> /etc/sysconfig/$PROFILE/$1.interface
/etc/init.d/netdevice.rc restart $1
echo "done." ; echo ; echoc GREEN "Premi INVIO per continuare ..." ; read x
