#!/bin/sh
# <BEGIN COPYRIGHT>
# This file is part of the "Bad Penguin" GNU/Linux distribution
# Copyright (C) 1997-98-99 by Antonio GALLO
# Home Page at ......: http://www.badpenguin.org
# Home Page at ......: http://www.linux.it/~agx/
# e-mail contact ....: mailto:agx@linux.it	mailto:agx@geocities.com
# This program is distributed under the GNU General Public License
# You are not allowed to remove the copyright notice
# <END COPYRIGHT>

# Display known network interfaces
# 1999-04-27, Version 1.0.0 by AGX
# 1999-10-26, Version 1.6.0 by AGX
# 1999-11-07, Version 1.6.1 by AGX : Utilizzo file temporanei standard

# --- Temp Script ---
TEMPDIR="$HOME/tmp"
[ ! -d $TEMPDIR ] && mkdir -p $TEMPDIR
TEMPFILE="$TEMPDIR/netdev-tempfile.$$"
TEMPSCRIPT="$TEMPDIR/netdev-tempscript.$$"
TEMPDATA="$TEMPDIR/netdev-tempdata.$$"
mkdir -p $TEMPMOUNT
trap 'rm -f $TEMPFILE $TEMPDATA $TEMPSCRIPT ; exit $USCITA' 0


# --- Controlli ---
if [ -f /etc/sysconfig/$PROFILE/network ]; then
  . /etc/sysconfig/$PROFILE/network
  if [ ! "$NETWORKING" = "YES" ]; then
    dialog --msgbox "La rete e' disabilitata !" 0 0
    USCITA=1 ; exit 1
  fi
else
  dialog --msgbox "La rete non e' stata configurata !" 0 0
  USCITA=1 ; exit 1
fi


# Scannin ...
while [ 0 ] ; do
  >$TEMPFILE

  # Enumerate present devices
  cat /proc/net/dev | grep ":" | grep -v "lo:" | cut -f 1 -d ':'| while read LINEA
  do
    [ "$LINEA" = "" ] && continue
    echo -n "$LINEA|"  >>$TEMPFILE
    if [ -f /etc/sysconfig/$PROFILE/${LINEA}.interface ]; then
      echo -n "Presente e configurato|" >>$TEMPFILE
    else
      echo -n "Presente ma non configurato|" >>$TEMPFILE
    fi
  done

  # Enumerate configured devices
  for i in /etc/sysconfig/$PROFILE/*.interface
  do
    [ ! -f $i ] && continue
    LINEA=`basename $i .interface`
    if ! grep -q $LINEA $TEMPFILE ; then
      echo -n "$LINEA|"  >>$TEMPFILE
      echo -n "Assente ma configurato|" >>$TEMPFILE    
    fi
  done

  # Add default menu'
  echo -n " | |AGGIUNGI|Aggiungi un interfaccia o alias" >>$TEMPFILE

  # Main Menu'
  IFS="|"
  dialog --backtitle "$VERSIONE" --title "Interfacce di rete" \
   --menu "Selezione un'interfaccia da configurare. In alternativa puoi\n\
aggiungerne di nuove. Per aggiungere un alias basta aggiungere al\n\
nome di un interfaccia il simbolo ':' seguito del numero\n\
dell'interfaccia\n" 21 78 10 `cat $TEMPFILE` 2>$TEMPDATA
  REPLY=$?
  if [ $REPLY = 1 -o $REPLY = 255 ]; then
    USCITA=1 ; exit 1
  fi
  CHOICE="`cat $TEMPDATA`"

  # Controllo scelta
  if [ "$CHOICE" = "AGGIUNGI" ]; then
    dialog --title "Aggiunta interfaccia o alias" \
      --inputbox "Inserisci il nome dell'interfaccia o alias da aggiungere" 0 0 2>$TEMPDATA
    REPLY=$?
    if [ $REPLY = 1 -o $REPLY = 255 ]; then
      continue
    fi
    CHOICE="`cat $TEMPDATA`"
    # Controllo scelta
    case "$CHOICE" in
      eth*|tr*|plip*|ppp*|dummy*)
        touch /etc/sysconfig/$PROFILE/$CHOICE.interface
        ;;
      *)
        dialog --title "Interfaccia errata" --msgbox "Hai inserito $CHOICE, non mi sembra il nome di un interfaccia !!!" 0 0
        ;;
    esac
  else
    # Sorry for the absolute path !
    /usr/local/lib/agx-userprofiles/netconf.sh $CHOICE
  fi

done
    