#!/bin/sh
# <BEGIN COPYRIGHT>
# This file is part of the "Bad Penguin" GNU/Linux distribution
# Copyright (C) 1997-98-99 by Antonio GALLO
# Home Page at ......: http://www.badpenguin.org
# Home Page at ......: http://www.linux.it/~agx/
# e-mail contact ....: mailto:agx@linux.it	mailto:agx@geocities.com
# This program is distributed under the GNU General Public License
# You are not allowed to remove the copyright notice
# <END COPYRIGHT>

# This script is part of "Bad Penguin" - http://www.linux.it/~agx/
# 1.0.0, AGX
# 1.2.0 - 19990427, AGX
# 1.4.1 - 19990615, AGX : remove swapfile only if unused
# 1999-11-07, Version 1.6.0 by AGX


# --- Temp Script ---
TEMPDIR="$HOME/tmp"
[ ! -d $TEMPDIR ] && mkdir -p $TEMPDIR
TEMPSCRIPT="$TEMPDIR/tempscript.$$"
TEMPDATA="$TEMPDIR/tempdata.$$"
trap 'rm -f $TEMPDATA $TEMPSCRIPT ; exit $USCITA' 0


# Get Settings
. /etc/sysconfig/$PROFILE/swap

# Flags
NO_ASKME_SIZE="NO"

# Display Current Settings, do you want to change them  ?
dialog	--title "Configurazione swapfile (memoria virtuale)" \
	--yesno "\nQueste sono le tue impostazioni Swap file attuali:\n\n\
 Swap Device : $SWAP_DEVICE\n\
 Dimension KB: $SWAP_SIZE_KB\n\
 Is it a file: $SWAP_FILE\n\n\
Vuoi cambiarle ?\n" 12 60
REPLY=$?
if [ $REPLY = 1 -o $REPLY = 255 ]; then
  USCITA=1 ; exit 1
fi

dialog --title "Configurazione della memoria virtuale" --menu "Scegli un'opzione per la tua partizione di swap" 13 75 5 \
"0" "Non voglio usare una partizione di swap                    " \
"1" "Uso una partizione di swap gia' esistente                  " \
"2" "Riuso il file di swap di Windows (win386.swp) [solo UMSDOS]" \
"3" "Uso un normale file di swap (/swapfile)                    " 2>$TEMPDATA
REPLY=$?
if [ $REPLY = 1 -o $REPLY = 255 ]; then
  USCITA=1 ; exit 1
fi
CHOICE=`cat $TEMPDATA`

if [ "$CHOICE" = "0" ]; then
  /usr/local/sbin/service swap stop
  SWAP_FILE="NONE"
  echo SWAP_FILE=$SWAP_FILE > /etc/sysconfig/$PROFILE/swap
  /usr/local/sbin/service swap start
  exit 0

elif [ "$CHOICE" = "1" ]; then
  SWAP_DEVICE=""
  SWAP_FILE="NONE"

  #<patched by BONF> - in 1.5.4.0
  #Warning: This works only under kernel 2.2
  DISKS=""
  for i in /proc/ide/hd* ; do
    [ ! -d $i ] && continue
    DISKS="$DISKS /dev/`basename $i`"
  done
  for i in /proc/scsi/sd*; do
    [ ! -d $i ] && continue
    DISKS="$DISKS /dev/`basename $i`"
  done
  SWAPLIST="`fdisk -l $DISKS | fgrep "Linux swap" 2> /dev/null`"
  #</BONF>

  if [ "$SWAPLIST" = "" ]; then
    dialog --title "Swap" --msgbox "Non hai una partizione di swap." 8 40
  else
    echo > $TEMPSCRIPT
    echo "Le seguenti partizioni sono state trovate :" >> $TEMPSCRIPT
    echo >> $TEMPSCRIPT
    echo "   Device Boot   Begin    Start      End   Blocks   Id  System" >> $TEMPSCRIPT
    echo "`echo "$SWAPLIST" | sed -n '1 p'`" >> $TEMPSCRIPT
    echo >> $TEMPSCRIPT
    echo "Inserisci il nome della partizione che vuoi usare ... " >> $TEMPSCRIPT
    dialog --title "Partizione di swap trovata" --inputbox "`cat $TEMPSCRIPT`" 18 70 "" 2> $TEMPDATA
    REPLY=$?
    rm -f $TEMPSCRIPT

    if [ $REPLY -eq 0 ]; then
      /usr/local/sbin/service swap stop

      dialog --yesno "Se questa e' la prima volta, allora devi\nformattare la partizione di swap.\n\
Vuoi che lo faccio io per te ?" 8 60
      REPLY=$?

      dialog --infobox "\n   Preparazione della partizione di Swap ... \n" 0 0
      SWAP_DEVICE=`cat $TEMPDATA`
      SWAP_FILE="NO"
      if [ $REPLY = 0 ]; then  
        echo "Controllo dei bad blocks ..."
        mkswap -c $SWAP_DEVICE
      else      
        echo "Preparazione della partizione di swap senza controllo dei bad block ..."
        mkswap $SWAP_DEVICE      
      fi
      if [ $? -ne 0 ]; then
        dialog --msgbox "\n Problema durante la formattazione della partizione di swap ! \n" 0 0
        USCITA=99 ; exit 99
      else
        NO_ASKME_SIZE="YES"
      fi	
    fi
 fi

elif [ "$CHOICE" = "2" ]; then
  dialog --title "Configurazione dello swap file" --infobox "\n Ricerca del file di swap di Windows ... \n" 0 0
  SWAP_FILE="YES"
  SWAP_DEVICE=`find /DOS -iname win386.swp`
  if [ "#$SWAP_DEVICE" = "#" ]; then
    dialog --title "Configurazione dello swap file" --msgbox "\n Non trovato! Usa /swapfile invece !! \n" 0 0
    SWAP_DEVICE="/swapfile"
    SWAP_FILE="YES"    
  fi

elif [ "$CHOICE" = "3" ]; then
  SWAP_DEVICE="/swapfile"
  SWAP_FILE="YES"
fi


if [ "#$SWAP_DEVICE" = "#" ]; then
  
dialog --title "Configurazione dello swap file" --msgbox "\n   Nessuna scelta effettuata !   \n" 0 0
  exit 0
fi


# Ask for SiZE
if [ ! "$NO_ASKME_SIZE" = "YES" ]; then
  dialog --title "Configurazione dello swap file" --inputbox "\n\
Per piacere scegli la dimensione dello swap file:\n\
   $SWAP_DEVICE \n\n\
RICRODA: se stai usando una partizione non eccederne le dimensioni !!\n\n\
La dimensione deve essere espressa in KB, i.e. 1MB=1024KB" \
  15 75 16384 2> $TEMPDATA
  REPLY=$?
  if [ $REPLY = 1 -o $REPLY = 255 ]; then
    USCITA=1 ; exit 1
  fi 
  SWAP_SIZE_KB=`cat $TEMPDATA` 
else
  SWAP_SIZE_KB=0
fi


/usr/local/sbin/service swap stop
if [ -f /swapfile ]; then
  echoc YELLOW "Rimuovo il vecchio file di swap"
  rm -f $SWAP_FILE
fi

echo "Scrittura del file di configurazione ..." 
echo SWAP_FILE=$SWAP_FILE       >  /etc/sysconfig/$PROFILE/swap
echo SWAP_DEVICE=$SWAP_DEVICE   >> /etc/sysconfig/$PROFILE/swap
echo SWAP_SIZE_KB=$SWAP_SIZE_KB >> /etc/sysconfig/$PROFILE/swap
/usr/local/sbin/service swap restart
echo ; echoc GREEN "Premi INVIO per continuare ..." ; read x
