#!/bin/sh
# Orginal source inspired from slackware setup
# <BEGIN COPYRIGHT>
# This file is part of the "Bad Penguin" GNU/Linux distribution
# Copyright (C) 1997-98-99 by Antonio GALLO
# Home Page at ......: http://www.badpenguin.org
# Home Page at ......: http://www.linux.it/~agx/
# e-mail contact ....: mailto:agx@linux.it	mailto:agx@geocities.com
# This program is distributed under the GNU General Public License
# You are not allowed to remove the copyright notice
# <END COPYRIGHT>


# Impostazioni del timezone
# /usr/lib/zoneinfo contiene i vari file del time-zone
# il file che contiene le impostazioni attuali e' /usr/lib/zoneinfo/localtime
# inoltre /usr/lib/zoneinfo/posixrules e' una copia di localtime
# 1999-04-27, Version 1.1.0 by AGX
# 1999-08-25, Versione 1.2.0 by AGX - Modificato per funzionare
#		indipendentemente dalla posizione della dir zoneinfo
# 1999-11-07, Version 1.6.0 by AGX


# --- Temp Script ---
TEMPDIR="$HOME/tmp"
[ ! -d $TEMPDIR ] && mkdir -p $TEMPDIR
TEMPSCRIPT="$TEMPDIR/tempscript.$$"
TEMPDATA="$TEMPDIR/tempdata.$$"
mkdir -p $TEMPMOUNT
trap 'rm -f $TEMPDATA $TEMPSCRIPT ; exit $USCITA' 0


# -----------------------------------------------------------------

if [ -f /etc/sysconfig/$PROFILE/timezone ]; then
	. /etc/sysconfig/$PROFILE/timezone
fi


if [ -d /usr/lib/zoneinfo ]; then
	ZONEDIR="/usr/lib/zoneinfo"
elif [ -d /usr/share/zoneinfo ]; then
	ZONEDIR="/usr/share/zoneinfo"
else
	echoc RED "Impossibile trovare la directory con le timezone !"
	sleep 2
	USCITA=1 ; exit 1
fi

# -----------------------------------------------------------------



# ----- Build the continent menu -----
echo -n "" > $TEMPSCRIPT
for i in $ZONEDIR/*; do
  if [ -d "$i" ]; then
    continent=`basename $i`
    echo -n "$continent::"  >> $TEMPSCRIPT
  fi
done
IFS=":"
dialog --title "Configurazione del Time Zone" --menu "Usa i tasti cursore per scegliere il tuo continente,\nquindi premi INVIO per confermare la scelta.\n\nIl timezone corrente e' [ $TIMEZONE ]." 22 60 12 `cat $TEMPSCRIPT` 2> $TEMPSCRIPT
if [ $? -ne 0 ]; then
  USCITA=1 ; exit 1
fi
continent=`cat $TEMPSCRIPT`


# ----- Build the timezone menu -----
echo -n "" > $TEMPSCRIPT
for i in $ZONEDIR/$continent/*; do
  if [ -f "$i" ]; then
    timezone=`basename $i`
    echo -n "$timezone::"  >> $TEMPSCRIPT
  fi
done
IFS=":"
dialog --title "Configurazione del Time Zone" --menu "Usa i tasti cursore per selezionare la tua timezone,\nquindi premi INVIO per confermare la scelta.\n\nIl time zone corrente e' [ $TIMEZONE ]." 22 60 12 `cat $TEMPSCRIPT` 2> $TEMPSCRIPT
if [ $? -ne 0 ]; then
  USCITA=1 ; exit 1
fi
timezone=`cat $TEMPSCRIPT`


#
/etc/init.d/clock.rc stop
echo "Inpostazione del timezone su : $continent/$timezone"
echo TIMEZONE="$continent/$timezone" > /etc/sysconfig/$PROFILE/timezone
# Restart clock
/etc/init.d/clock.rc restart
echo ; echoc GREEN "Premi INVIO per continuare ..." ; read x
