#!/bin/sh
# <BEGIN COPYRIGHT>
# This file is part of the "Bad Penguin" GNU/Linux distribution
# Copyright (C) 1997-98-99 by Antonio GALLO
# Home Page at ......: http://www.badpenguin.org
# Home Page at ......: http://www.linux.it/~agx/
# e-mail contact ....: mailto:agx@linux.it	mailto:agx@geocities.com
# This program is distributed under the GNU General Public License
# You are not allowed to remove the copyright notice
# <END COPYRIGHT>

# Modified by : AGX in 1998 to run on AGX-Linux
# 1997-02-14, Version 1.1.0 by AGX
# 1999-04-27, Version 1.2.0 by AGX
# 1999-11-12, Version 1.6.0 by AGX

if [ ! -d /usr/share/consoletrans ]; then
  dialog \
    --title "La directory con i caratteri Unicode non e' stata trovata !" \
    --msgbox "Impossibile trovare i file con le mappe dei caratteri Unicode" 9 40
  exit 1
fi


# --- Temp Script ---
TEMPDIR="$HOME/tmp"
[ ! -d $TEMPDIR ] && mkdir -p $TEMPDIR
TEMPSCRIPT="$TEMPDIR/tempscript.$$"
TEMPDATA="$TEMPDIR/tempdata.$$"
mkdir -p $TEMPMOUNT
trap 'rm -f $TEMPDATA $TEMPSCRIPT ; exit $USCITA' 0


# Get Current Font value
. /etc/sysconfig/$PROFILE/unimap

cat << EOF > $TEMPSCRIPT
dialog --title "Seleziona la mappa Unicode" --menu "
Usa i tasti cursori per scegliere una mappa unicode.
Quindi premi INVIO per confermare la scelta.

Il valore attuale e' [ `basename $UNICODEMAP .uni` ]
" 25 68 12 \\
EOF

for mapname in /usr/share/consoletrans/*; do
   REALNAME="`basename $mapname .uni`"
   echo "\"$REALNAME\" \"\" \\" >> $TEMPSCRIPT
done

echo "2> $TEMPDATA" >> $TEMPSCRIPT
echo 'ERROR=$?' >> $TEMPSCRIPT
echo 'if [ $ERROR = 1 -o $ERROR = 255 ]; then' >> $TEMPSCRIPT
echo '  USCITA=1 ; exit 1' >> $TEMPSCRIPT
echo 'fi' >> $TEMPSCRIPT

# Run the script
sh $TEMPSCRIPT
if [ $? -eq 0 ]; then
  MAPNAME="`cat $TEMPDATA`"
  # Load keyboard map (if any) when booting
  echo UNICODEMAP=/usr/share/consoletrans/$MAPNAME.uni > /etc/sysconfig/$PROFILE/unimap
  # Load the new keytable
  /etc/init.d/unicode-map.rc init
  /etc/init.d/unicode-map.rc start
  echo -e "\nPremi INVIO per continuare ..."
  read x
fi
