#!/bin/sh
# <BEGIN COPYRIGHT>
# This file is part of the "Bad Penguin" GNU/Linux distribution
# Copyright (C) 1997-98-99 by Antonio GALLO
# Home Page at ......: http://www.badpenguin.org
# Home Page at ......: http://www.linux.it/~agx/
# e-mail contact ....: mailto:agx@linux.it	mailto:agx@geocities.com
# This program is distributed under the GNU General Public License
# You are not allowed to remove the copyright notice
# <END COPYRIGHT>

# Configure the update daemon
# 1999-04-27, Version 1.0.0 by AGX

TEMPDIR="$HOME/tmp"
[ ! -d $TEMPDIR ] && mkdir -p $TEMPDIR
TEMPDATA=$TEMPDIR/tempdata.$$
trap 'rm -f $TEMPDATA ; exit $USCITA' 0
USCITA=0


# Get Settings
if [ -f /etc/sysconfig/$PROFILE/update ]; then
  . /etc/sysconfig/$PROFILE/update
else
  FLUSHTIME="30"
  SYNCTIME="300"
  echo "FLUSHTIME=$FLUSHTIME" > /etc/sysconfig/$PROFILE/update
  echo "SYNCTIME=$SYNCTIME"  >> /etc/sysconfig/$PROFILE/update
  echo "RUNME=AUTO"          >> /etc/sysconfig/$PROFILE/update
fi


# Display Current Settings, do you want to change them  ?
dialog	--title "FileSystem Flush Time" \
	--yesno "\nImpostazioni attuali:\n\n\
 Flush Time .......: $FLUSHTIME\n\
 Sync Time ........: $SYNCTIME \n\n\
Desideri cambiarle ?\n" 12 60
if [ $? -ne 0 ]; then
  exit 1
fi

# Ask Flush Time
dialog --title "Inserisci il nuovo Flush time" --inputbox "Flush time in secondi: " 8 60 "$FLUSHTIME" 2> $TEMPDATA
REPLY=$?
if [ $REPLY = 0 ]; then
  FLUSHTIME="`cat $TEMPDATA`"
fi

if [ $[FLUSHTIME] -lt 5 ]; then
  dialog --msgbox "Spiacente, devi specificare almeno 5 secondi !" 5 60
  exit 1
fi

# Ask Sync Time
dialog --title "Inserisci il nuovo Sync Time" --inputbox "Sync Time : " 8 60 "$SYNCTIME" 2> $TEMPDATA
if [ $? = 0 ]; then
  SYNCTIME="`cat $TEMPDATA`"
fi

if [ $[ SYNCTIME] -lt 30 ]; then
  dialog --msgbox "Spiacente, devi specificare almeno 30 secondi !" 5 60
  exit 1
fi 


# Save settings
/usr/local/sbin/service update stop
echo "FLUSHTIME=$FLUSHTIME" > /etc/sysconfig/$PROFILE/update
echo "SYNCTIME=$SYNCTIME"  >> /etc/sysconfig/$PROFILE/update
echo "RUNME=AUTO"          >> /etc/sysconfig/$PROFILE/update
/usr/local/sbin/service update init
/usr/local/sbin/service update start

echo -e "\nPremi INVIO per continuare ..."
read x
